// <auto-generated>
//  automatically generated by the FlatBuffers compiler, do not modify
// </auto-generated>

namespace JS.MyGladiator.ChattingServer.Common.Protocol
{

using global::System;
using global::FlatBuffers;

public struct RequestSendMessage : IFlatbufferObject
{
  private Table __p;
  public ByteBuffer ByteBuffer { get { return __p.bb; } }
  public static void ValidateVersion() { FlatBufferConstants.FLATBUFFERS_1_11_1(); }
  public static RequestSendMessage GetRootAsRequestSendMessage(ByteBuffer _bb) { return GetRootAsRequestSendMessage(_bb, new RequestSendMessage()); }
  public static RequestSendMessage GetRootAsRequestSendMessage(ByteBuffer _bb, RequestSendMessage obj) { return (obj.__assign(_bb.GetInt(_bb.Position) + _bb.Position, _bb)); }
  public void __init(int _i, ByteBuffer _bb) { __p = new Table(_i, _bb); }
  public RequestSendMessage __assign(int _i, ByteBuffer _bb) { __init(_i, _bb); return this; }

  public string SenderName { get { int o = __p.__offset(4); return o != 0 ? __p.__string(o + __p.bb_pos) : null; } }
#if ENABLE_SPAN_T
  public Span<byte> GetSenderNameBytes() { return __p.__vector_as_span<byte>(4, 1); }
#else
  public ArraySegment<byte>? GetSenderNameBytes() { return __p.__vector_as_arraysegment(4); }
#endif
  public byte[] GetSenderNameArray() { return __p.__vector_as_array<byte>(4); }
  public string Body { get { int o = __p.__offset(6); return o != 0 ? __p.__string(o + __p.bb_pos) : null; } }
#if ENABLE_SPAN_T
  public Span<byte> GetBodyBytes() { return __p.__vector_as_span<byte>(6, 1); }
#else
  public ArraySegment<byte>? GetBodyBytes() { return __p.__vector_as_arraysegment(6); }
#endif
  public byte[] GetBodyArray() { return __p.__vector_as_array<byte>(6); }

  public static Offset<JS.MyGladiator.ChattingServer.Common.Protocol.RequestSendMessage> CreateRequestSendMessage(FlatBufferBuilder builder,
      StringOffset SenderNameOffset = default(StringOffset),
      StringOffset BodyOffset = default(StringOffset)) {
    builder.StartTable(2);
    RequestSendMessage.AddBody(builder, BodyOffset);
    RequestSendMessage.AddSenderName(builder, SenderNameOffset);
    return RequestSendMessage.EndRequestSendMessage(builder);
  }

  public static void StartRequestSendMessage(FlatBufferBuilder builder) { builder.StartTable(2); }
  public static void AddSenderName(FlatBufferBuilder builder, StringOffset SenderNameOffset) { builder.AddOffset(0, SenderNameOffset.Value, 0); }
  public static void AddBody(FlatBufferBuilder builder, StringOffset BodyOffset) { builder.AddOffset(1, BodyOffset.Value, 0); }
  public static Offset<JS.MyGladiator.ChattingServer.Common.Protocol.RequestSendMessage> EndRequestSendMessage(FlatBufferBuilder builder) {
    int o = builder.EndTable();
    return new Offset<JS.MyGladiator.ChattingServer.Common.Protocol.RequestSendMessage>(o);
  }
};


}
